import 'package:flutter/material.dart';

import '../../mobile_ui.dart';

class SwitchFormInput extends FormInputBase<bool> {
  SwitchFormInput(
      {Key? key,
      String? labelText,
      bool? initialValue,
      ValueController<bool>? controller,
      FocusNode? focusNode,
      bool readOnly = false,
      bool enabled = true,
      bool isRequired = false,
      bool? isDense,
      FormFieldSetter<bool>? onSaved,
      ValueChanged<bool?>? onChanged,
      AutovalidateMode? autovalidateMode,
      TextAlign labelAlign = TextAlign.left,
      ValueValidator<bool?>? validator,
      FieldOrientation orientation = FieldOrientation.horizontal,
      EdgeInsetsGeometry contentPadding = const EdgeInsets.all(0),
      EdgeInsetsGeometry margin = const EdgeInsets.symmetric(vertical: 8),
      ControlPosition controlPosition = ControlPosition.trailing,
      double spacingFlactor = 1,
      double? labelWidth,
      int errorMaxLines = 1})
      : super(
          key: key,
          labelWidth: labelWidth,
          initialValue: controller != null ? null : (initialValue ?? false),
          onSaved: onSaved,
          validator: validator,
          enabled: enabled,
          autovalidateMode: autovalidateMode,
          orientation: orientation,
          controlPosition: controlPosition,
          labelText: labelText,
          labelAlign: labelAlign,
          spacingFlactor: spacingFlactor,
          isDense: isDense,
          valueController: controller,
          onChanged: onChanged,
          isRequired: isRequired,
          contentPadding: contentPadding,
          errorMaxLines: errorMaxLines,
          margin: margin,
          // ignore: missing_return
          builder: (field) {
            FormInputBase<bool> widget = field.widget as FormInputBase<bool>;
            FormInputStateBase<bool> state = field as FormInputStateBase<bool>;
            var switchButton = Switch(
                focusNode: focusNode,
                onChanged: enabled == true
                    ? (value) {
                        if (readOnly == true) return;
                        state.changeValue(value);
                      }
                    : null,
                value: state.effectiveValueController!.value!,
                materialTapTargetSize: MaterialTapTargetSize.shrinkWrap);
            return widget.buildField(field, switchButton);
          },
        );
}
